// Created by fizzim.pl version 5.20 on 2019:04:26 at 14:00:34 (www.fizzim.com)

module seq101 (
  output wire det,
  input wire clk,
  input wire rstn,
  input wire sin
);

  // state bits
  parameter 
  state0 = 3'b000, // extra=00 det=0 
  state1 = 3'b010, // extra=01 det=0 
  state2 = 3'b100, // extra=10 det=0 
  state3 = 3'b001; // extra=00 det=1 

  reg [2:0] state;
  reg [2:0] nextstate;

  // comb always block
  always @* begin
    nextstate = state; // default to hold value because implied_loopback is set
    case (state)
      state0: begin
        if (sin == 1) begin
          nextstate = state1;
        end
        else begin
          nextstate = state0;
        end
      end
      state1: begin
        if (sin == 0) begin
          nextstate = state2;
        end
        else begin
          nextstate = state1;
        end
      end
      state2: begin
        if (sin == 1) begin
          nextstate = state3;
        end
        else begin
          nextstate = state0;
        end
      end
      state3: begin
        if (sin == 0) begin
          nextstate = state2;
        end
        else begin
          nextstate = state1;
        end
      end
    endcase
  end

  // Assign reg'd outputs to state bits
  assign det = state[0];

  // sequential always block
  always @(posedge clk or negedge rstn) begin
    if (!rstn)
      state <= state0;
    else
      state <= nextstate;
  end

  // This code allows you to see state names in simulation
  `ifndef SYNTHESIS
  reg [47:0] statename;
  always @* begin
    case (state)
      state0:
        statename = "state0";
      state1:
        statename = "state1";
      state2:
        statename = "state2";
      state3:
        statename = "state3";
      default:
        statename = "XXXXXX";
    endcase
  end
  `endif

endmodule
